__file__ = 'ky_data_structures.py'
__usage__ = '''Various
    Ky data structures.
    <identifier> = Node (..)'''
__description__ = '''Ky data structure classes.  Currently only contains
the Node structure for Syntax Trees'''

__author__ = 'Timothy Wakeham (timmeh)'
__contact__ = 'timmeh@hiddenworlds.org'
__updated__ = '30-03-2008 @ 11:13:48'

__todo__ = None

#start
class Node:

    def __init__(self, parent, label, token, *children):
        self.parent = parent
        self.children = children

    def get_child(self, value):
        return self.children[-1]

    def set_child(self, value):
        self.children.append(self.children)

    child = property(get_child, set_child)

    def __getitem__(self, key):
        return self.children[key]

    def __setitem__(self, key, val):
        self.children[key] = val
